package bvh.fry;

import robocode.*;
import robocode.util.Utils;
import java.awt.geom.Point2D;


class DoelGolf extends Golf {
   boolean ontwijken = false;

   /**
    * Creates a new DoelGolf object.
    *
    * @param vuurpositie DOCUMENT ME!
    * @param doel DOCUMENT ME!
    * @param kogelSnelheid DOCUMENT ME!
    * @param cirkelRichting DOCUMENT ME!
    * @param tijd DOCUMENT ME!
    * @param stats DOCUMENT ME!
    */
   public DoelGolf(Point2D.Double vuurpositie, Point2D.Double doel, double kogelSnelheid, double cirkelRichting, long tijd,
      double straal, double[] stats) {
      super(vuurpositie, doel, kogelSnelheid, cirkelRichting, tijd, straal, stats);
   }

   public DoelGolf(Point2D.Double vuurpositie, Point2D.Double doel, double kogelSnelheid, double cirkelRichting, long tijd,
      double straal, double[] stats, boolean ontwijken) {
      super(vuurpositie, doel, kogelSnelheid, cirkelRichting, tijd, straal, stats);
      this.ontwijken = ontwijken;
   }

   /**
    * DOCUMENT ME!
    *
    * @param doel DOCUMENT ME!
    * @param tijd DOCUMENT ME!
    *
    * @return DOCUMENT ME!
    */
   public boolean voorbijDoel(Point2D.Double doel, long tijd) {
//      System.out.println("Golf.bijwerken():");
      boolean verwijderen = false;
      double nabijheid;
//      long    deltaTijd = tijd - laatsteTijd;
//      double  dx = (doel.getX() - vorigePositieDoel.getX()) / deltaTijd;
//      double  dy = (doel.getY() - vorigePositieDoel.getY()) / deltaTijd;

      while (laatsteTijd < tijd) {
         straal += kogelSnelheid;
         nabijheid = straal - this.distance(vorigePositieDoel);

         if (nabijheid > -RAAKAFSTAND) {
            ontwijken = false;

            if (nabijheid < RAAKAFSTAND) {
               // hier niet moeilijk doen met breedte van bot...
               double exacteRichtingNaarDoel = BotUtils.bepaalRichting(this, vorigePositieDoel);
               int    hitGF = bepaalGF(exacteRichtingNaarDoel);
               //double waarde = (ontwijken) ? 1D : 0.01D;
               //double waarde = (ontwijken) ? 0.01D : 0;
               double waarde = 0D;
               bijwerkenHits(hitGF, waarde);
            }
         }

         if (nabijheid > RAAKAFSTAND) {
            verwijderen = true;
         }

         laatsteTijd++;
//         vorigePositieDoel.setLocation(vorigePositieDoel.getX() + dx, vorigePositieDoel.getY() + dy);
      }

      return verwijderen;
   }

   /**
    * DOCUMENT ME!
    *
    * @param kogelSnelheid DOCUMENT ME!
    *
    * @return DOCUMENT ME!
    */
   private int geefSchattingGF(double kogelSnelheid) {
      int schattingGF = GF_MIDDEN;

      for (int gf = 0; gf <= (2 * GF_MIDDEN); gf++) {
         if (stats[gf] > stats[schattingGF]) {
            schattingGF = gf;
         }
      }
      return (schattingGF);
   }

   public Point2D.Double geefVerwachtePositie(long tijd) {
      double r = straal;
      long t = laatsteTijd;

      while (t < tijd) {
         r += kogelSnelheid;
         t++;
      }

      int schattingGF = geefSchattingGF(kogelSnelheid);

      double schattingHoek = richting + cirkelRichting * (schattingGF - GF_MIDDEN);

//System.out.println("DoelGolf.geefVerwachtePositie(): schattingGF = "+schattingGF);
//System.out.println("                                 schttngHoek = "+schattingHoek);
//System.out.println("                                 echte  Hoek = "+BotUtils.bepaalRichting(this,p));
      return (new Point2D.Double(this.getX() + Math.sin(schattingHoek) * r, this.getY() + Math.cos(schattingHoek) * r));
   }

   public Point2D.Double geefPositieVoorStraal(double s) {
      int schattingGF = geefSchattingGF(kogelSnelheid);
      double schattingHoek = richting + cirkelRichting * (schattingGF - GF_MIDDEN);

      return (new Point2D.Double(this.getX() + Math.sin(schattingHoek) * s, this.getY() + Math.cos(schattingHoek) * s));
   }
   
   public Point2D.Double geefHOTPositie(long tijd) {
      double r = straal;
      long t = laatsteTijd;

      while (t < tijd) {
         r += kogelSnelheid;
         t++;
      }

      int schattingGF = GF_MIDDEN;
      double schattingHoek = richting + cirkelRichting * (schattingGF - GF_MIDDEN);

      return (new Point2D.Double(this.getX() + Math.sin(schattingHoek) * r, this.getY() + Math.cos(schattingHoek) * r));
   }

   public Point2D.Double geefMaxPositie(long tijd) {
      double r = straal;
      long t = laatsteTijd;

      while (t < tijd) {
         r += kogelSnelheid;
         t++;
      }

      int schattingGF = 0;
      double schattingHoek = richting + cirkelRichting * (schattingGF - GF_MIDDEN);

      return (new Point2D.Double(this.getX() + Math.sin(schattingHoek) * r, this.getY() + Math.cos(schattingHoek) * r));
   }
}
